"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const apollo_server_core_1 = require("apollo-server-core");
const graphql_playground_html_1 = require("@apollographql/graphql-playground-html");
const nativeApollo_1 = require("./nativeApollo");
class ApolloServer extends apollo_server_core_1.ApolloServerBase {
    createGraphQLServerOptions(req, res) {
        const _super = name => super[name];
        return __awaiter(this, void 0, void 0, function* () {
            return _super("graphQLServerOptions").call(this, { req, res });
        });
    }
    supportsSubscriptions() {
        return true;
    }
    createHandler({ path } = {}) {
        if (!path)
            path = '/graphql';
        this.graphqlPath = path;
        const handler = (req, res) => {
            if (req.url !== path)
                return;
            if (this.playgroundOptions && req.method === 'GET') {
                const playgroundRenderPageOptions = Object.assign({ endpoint: path, subscriptionEndpoint: this.subscriptionsPath }, this.playgroundOptions);
                res.setHeader('Content-Type', 'text/html');
                const playground = graphql_playground_html_1.renderPlaygroundPage(playgroundRenderPageOptions);
                // res.setHeader('Content-Length', playground.length)
                res.write(playground);
                res.end();
                return;
            }
            return nativeApollo_1.graphqlNative(this.createGraphQLServerOptions.bind(this))(req, res);
        };
        return handler;
    }
}
exports.ApolloServer = ApolloServer;
//# sourceMappingURL=ApolloServer.js.map